$purple: #a050be;
$light-grey: #eaeaeb;
$dark-grey: #464646;
$yellow:#FABE50;
$img-width: 45%;

%no-decoration{text-decoration: none;}
%u-decoration{text-decoration: underline;}

@mixin reset-list{
    margin: 0;
    padding: 0;
    list-style: none;
}
@mixin flx($property, $jty-cnt){
    display: flex;
    #{$property}:$jty-cnt;
}

@mixin for-phone-only{
    @media (max-width:767.98px) {
        @content;
        
    }
}
@mixin for-tablet-only{
    @media (min-width:768px) and (max-width:1199.98px) {
        @content;
        
    }
}
@mixin for-desktop-only{
    @media (min-width:1200px) {
        @content;
        
    }
}


@function calculateRem($size) {
    $remSize: calc($size / 16px);
    @return #{$remSize}rem;
  }

@mixin fontSize($size){
    font-size: calculateRem($size);
}


@import 'header', 'footer', 'about', 'article', 'collection', 'contact';

$directions: top, bottom, left, right;
$layout-margin-size: 10px;

@each $direction in $directions{
    %no-margin-#{$direction} {margin-#{$direction}: 0}
    %default-margin-#{$direction} {margin-#{$direction}: $layout-margin-size}
    %double-margin-#{$direction} {margin-#{$direction}: $layout-margin-size * 2}
    %half-margin-#{$direction} {margin-#{$direction}: calc($layout-margin-size / 2)}
}
.main{
    display: flex;
    justify-content: center;
    flex-wrap: wrap;
    font-family: Arial, Helvetica, sans-serif;

    &__content{
        width: 70%;
        padding: 40px 8px;
        @include for-phone-only{
            width: 100%;
        }
    }
    &__post{
        text-align: center;
        max-width: 800px;
        margin-left: auto;
        margin-right: auto;
    }
    &__title{
        @extend %no-decoration;
        @include fontSize(22px);
        color: $dark-grey;
        letter-spacing: 1.5;
        &:hover{
            color: $purple;
        }
    }
    &__subtitle{
        display: flex;
        justify-content: center;
        align-items: center;
        @extend %default-margin-top, %double-margin-bottom
        
    }
    &__date{
        @extend %no-margin-top, %no-margin-bottom, %default-margin-left,  %default-margin-right;
        @include fontSize(12px);
        font-style: italic;
    }
    &__tag{
        @include fontSize(14px);
        padding: 5px 7px;
        color: $purple;
        border: 1px solid $purple;
        @extend %no-margin-top, %no-margin-bottom, %default-margin-left,  %default-margin-right;
    }
    &__details{
        border: 1px solid $light-grey;

    }
    &__img{
        width: 100%;
    }
    &__description{
        padding: 40px 0 25px;
        max-width: 650px;
        margin-left: auto;
        margin-right: auto;
        @include fontSize(14px);
    }
    &__btn{
        @extend %no-decoration;
        @include fontSize(16px);
        letter-spacing: 1.5;
        color: $purple;
        background-color: $yellow;
        padding: 10px 20px;
        transition: .3s;
        &:hover{
            color: $yellow;
            background-color: $purple;
        }
    }
    &__info{
        display: flex;
        justify-content: space-between;
        align-items: center;
        border-top: 1px solid $light-grey;
        margin-top: 30px;
    }
    &__author{
        width: 50%;
        border-right: 1px solid $light-grey;
    }
    &__p{
        @include fontSize(14px);;
        color: $dark-grey;
        margin-top: 10px;
        margin-bottom: 10px;
    }
    &__comments{
        width: 50%;
    }
    &__a{
        @extend %no-decoration;
        @include fontSize(14px);
        color: $dark-grey;
        margin-top: 10px;
        margin-bottom: 10px;
        &:hover{
            color: $purple;
        }
    }
    &__sidebar{
        width: 25%;
        padding: 40px 10px;

    }
    .sidebar{
        &__top{
            border: 1px solid $light-grey;
            padding: 15px 20px;
        }
        &__title{
            background-color: $yellow;
            text-align: center;
            padding: 10px 20px;
            @extend %no-margin-top, %no-margin-bottom, %no-margin-left,  %no-margin-right;
            letter-spacing: 1.5px;
        }
        &__posts{
            @include reset-list;
        }
        &__list{
            display: flex;
            justify-content: center;
            flex-wrap: wrap;
            align-items: center;
            padding: 15px 0;
            &:not(:last-child){
                border-bottom: 1px dashed $light-grey;
            }
        }
        &__img{
            width: 40%;
        }
        &__details{
            width: 50%;
            padding-left: 10px;
        }
        &__post-title{
            @include fontSize(14px);
            color: $purple;
            @extend %no-decoration;
            &:hover{
                @extend %u-decoration;
            }
        }
        &__post-dade{
            @include fontSize(12px);
            margin: 5px 0 0 0;
        }
    }
}